//Julia-Menge (multithreaded, mit Klasse Complex) mit BSM zeichnen
//Mit Taste 'd' kann man zwischen Fluchtgeschwindigkeit und Distance Estimation-Methode 
//umschalten. Ein Pixel gehört zur Julia-Menge, wenn zwei oder drei Eckpunkte im Konvergenzbereich liegen
/////////////////////////////////////////////////////////////////////////////////////////////////////////
ArrayList<Threads> threads;
Complex zNeu,zAlt,z,z0,z1,C,zA,zB,zF1,zF2;
double xU = -1.8; 
double yU = -1.8; 
double xO = 1.8;
double yO = 1.8;
double zoomFaktor=1;
double wh = xO-xU;
double D;
double x0,y0;
double l0,l1,laenge;
double a,b;
float A,B;
float aP,bP;
boolean FPzeichnen = false;
boolean Julia;
boolean farbig = false;
boolean orbitZeichnen = false;
boolean cWerteEintragen= false; 
boolean DEM = false;
int maxiterations = 200;
int orbitZeichnenAb = 1000;
int punktGroesse;
int anzahlOrbitPunkte = 2000;
double massFuerUnendlich = 1000;
double Periode = 37.0;
double alpha ; //Winkel 
double x,y; //Koordinaten indiff.FP
double e = 0.0005; //Epsilon
int nummerThread;
int anzahlThreads = Runtime.getRuntime().availableProcessors(); 
color farbe;
boolean gelbC,rotC;

void setup() {
  background(255);
  noLoop();
  colorMode(RGB);
  threads = new  ArrayList<Threads>();   
  size(800, 800);
  
  //c-Wert
  x0=-0.191; y0=0.6537;
  C = new Complex(x0,y0);
  z0 = new Complex(0,0);
  Julia = false;//Erst Mandelbrot-Menge zur Wahl von c zeichnen
  nummerThread =0;
  starteThreads(xU, yU, maxiterations, massFuerUnendlich, wh, nummerThread, x0, y0,Julia,e,DEM); 
}

/////////////////////////////////////////////////////////////////
void starteThreads(double px, double py, int pmaxiterations, double pUnendlich, double pwh, int nummer, double X0, double Y0, boolean julia, double e, boolean DEM){
  
  xU = px; yU = py;
  x0 = X0; y0 = Y0;
  nummerThread = nummer;
  maxiterations = pmaxiterations;
  massFuerUnendlich = pUnendlich;
  wh = pwh;//println(wh/anzahlThreads); double y= yU;
  double  y= yO-wh/anzahlThreads;
  while(nummerThread <anzahlThreads){
        Threads t = new Threads(xU,y,maxiterations,massFuerUnendlich,wh/anzahlThreads, nummerThread,x0,y0,Julia,e,DEM);
        threads.add(t);
        t.start(); 
        nummerThread++;
        y=y-wh/anzahlThreads;
        delay(50);//zur Verringerung der Pixelfehler 
  }  
}
//////////////////////////////////////////////////////////////

void draw() {
 
  for(Threads t: threads){
      while (t.running){       
            try{
            Thread.sleep(10);  
            }catch (Exception e) {  }  ;                
       }
       if(t.gibNummer() ==0)println("fertig!");
  }
  
  for (int i=0; i<threads.size(); i++){
    image(threads.get(i).pg,0,i*height/anzahlThreads);
   
  }  
  
  if(orbitZeichnen == true){
      int m =juliaIteration(z0,anzahlOrbitPunkte);
      println(m);//Kontrolle
      orbitZeichnen = false;
      farbig = false;
  }
  
  if(FPzeichnen==true){
    println("Fixpunkte eintragen");
    fixPunkteBestimmen();
    fixPunkteEintragen(zF1,zF2);
  }
  
   if(cWerteEintragen && !Julia){
  
    if(gelbC){
        punktGroesse = 6;
        color f1 = color(255,255,0);
        color f2 = f1;
        zA =  new Complex(-0.7356528043746948D,0.13968722522258759D);
        zB =  new Complex(-0.39054,-0.58679);
        punkteEintragen(zA,zB,f1,f2,punktGroesse);
        
        zA =  new Complex(-0.481762,-0.531657);
        zB =  new Complex(0.25,-0.5642857551574707D);
        punkteEintragen(zA,zB,f1,f2,punktGroesse);
        
        zA =  new Complex(0.32,0.043);
        zB =  new Complex(-0.7464286088943481D,0.0035715103149414062D);
        punkteEintragen(zA,zB,f1,f2,punktGroesse);
       
        zA =  new Complex(-1.48,0);
        zB =  new Complex(-0.75,0);
        punkteEintragen(zA,zB,f1,f2,punktGroesse);
        
        zA =  new Complex(0,0);
        zB =  new Complex(0.2696255147457123D,0.005362700670957565D);
        punkteEintragen(zA,zB,f1,f2,punktGroesse);
       
        zA =  new Complex(0.06834238767623901D,0.6154803037643433D);
        zB =  new Complex(-0.10933917760848999D,0.894686222076416D);
        punkteEintragen(zA,zB,f1,f2,punktGroesse);    
    }
    if(rotC){
      punktGroesse = 4;
       color f3 = color(255,0,0);
       color f4 = f3;
       double k = Periode;
       double delta = 2*Math.PI/k;
       alpha = delta;
       while(alpha<2*Math.PI){
         berechneK(alpha); 
         punkteEintragen(z,z,f3,f4,punktGroesse);//doppelt, um keine neue Methode zu schreiben
         alpha = alpha + delta; 
       }    
    }    
  }       
}
///////////////////////////////////////////////////////////////////////
void fixPunkteBestimmen(){
 
  zF1= new Complex(0,0);
  zF2= new Complex(0,0);
  
  zF1 = C.multiply(-4D); 
  zF1 = zF1.addC(1D); 
  zF1 = zF1.sqrtC(); 
  zF2=zF1;
  zF1 = zF1.multiply(-0.5D);
  zF2 = zF2.multiply(0.5D);
  
  zF1 = zF1.addC(0.5D); l0 = zF1.getLength(); 
  zF2 = zF2.addC(0.5D); l1 = zF2.getLength();
  if(l0 < l1){ //erster Wert soll auf Julia-Menge liegen
    z  = zF2; 
    zF2 = zF1;
    zF1 = z;
  }  
}
////////////////////////////////////////////////////////////////
Complex berechneK(double Alpha){
 
  x = Math.cos(Alpha)/2 - Math.cos(2*Alpha)/4;
  y = Math.sin(Alpha)/2 - Math.sin(2*Alpha)/4;
  z = new Complex(x,y);
  
  return z;
}
///////////////////////////////////////////////////////////////
void fixPunkteEintragen(Complex Z1, Complex Z2){  
  strokeWeight(10);
  stroke(255,0,255);
  //Fixpunkt (abstoßend) auf Julia-Menge
  a = Z1.getRealPart();
  b = Z1.getImaginaryPart();
  aP = map((float)a,(float)xU,(float)xO,0,width);
  bP = map((float)b,(float)yU,(float)yO,height,0); 
  point(aP,bP); 
  //Fixpunkt (anziehend) in Gefangenen-Menge
  stroke(0,0,255);
  a = Z2.getRealPart();
  b = Z2.getImaginaryPart();
  aP = map((float)a,(float)xU,(float)xO,0,width);
  bP = map((float)b,(float)yU,(float)yO,height,0); 
  point(aP,bP); 
}
///////////////////////////////////////////////////////////////
void punkteEintragen(Complex Z1, Complex Z2, color farbe1, color farbe2, int punktGroesse){
   strokeWeight(punktGroesse);
   
  //Fixpunkt (abstoßend) auf Julia-Menge oder spezieller c-Wert
  stroke(farbe1);
  aP = map((float)Z1.getRealPart(),(float)xU,(float)xO,0,width);
  bP = map((float)Z1.getImaginaryPart(),(float)yU,(float)yO,height,0); 
  point(aP,bP); 
 
  //Fixpunkt (anziehend) in Gefangenen-Menge  oder spezieller c-Wert
  stroke(farbe2);
  aP = map((float)Z2.getRealPart(),(float)xU,(float)xO,0,width);
  bP = map((float)Z2.getImaginaryPart(),(float)yU,(float)yO,height,0); 
  point(aP,bP);
}
//////////////////////////////////////////////////////////////////////
int juliaIteration(Complex Z, int M) {
  int maxIt = M;
  int n = 0;
  a = Z.getRealPart();
  b = Z.getImaginaryPart(); 
  zAlt = new Complex(a,b);
  if(farbig) {
     colorMode(HSB,255,255,255);
     farbe = color(random(0,255),255,255);
     stroke(farbe);
     
   }else{
      stroke(0,255,0);
      colorMode(RGB, 255,255,255);
    }  
  strokeWeight(6);
 
  A = map((float)a,(float)xU,(float)xO,0,width);
  B = map((float)b,(float)yU,(float)yO,height,0); 
  point(A,B);
  
  while (n < maxIt) {
    zNeu = zAlt.multiply(zAlt);
    zNeu = zNeu.addC(C);
    laenge = zNeu.getLength();
    if (laenge > massFuerUnendlich) {
      break;  // Bail
    }
    a = zNeu.getRealPart();
    b = zNeu.getImaginaryPart();
    if(orbitZeichnen && n > orbitZeichnenAb){         
      A = map((float)a,(float)xU,(float)xO,0,width);
      B = map((float)b,(float)yU,(float)yO,height,0);
      if(farbig) stroke(farbe);
        else stroke(255,0,0);
      strokeWeight(punktGroesse);
      point(A,B); 
    }
    zAlt = new Complex(a,b);
    n++; 
  }
  colorMode(RGB);
  return n;
 }

/////////////////////////////////////////////////////////////////
void mousePressed() { 
     nummerThread =0;
     threads = new  ArrayList<Threads>(); 
     double xUNeu, xONeu, yUNeu, yONeu;//Temp. Speicher
    
     
      if (mouseButton == LEFT){
        if(keyPressed == true && keyCode == SHIFT){//Vergrößern
          xUNeu = map(mouseX,0,width,(float)xU,(float)xO)-(xO-xU)/10;
          xONeu = map(mouseX,0,width,(float)xU,(float)xO)+(xO-xU)/10; 
          xU = xUNeu; xO = xONeu; 
          yUNeu = map(mouseY,height,0,(float)yU,(float)yO)-(yO-yU)/10;
          yONeu = map(mouseY,height,0,(float)yU,(float)yO)+(yO-yU)/10; 
          yU =yUNeu; yO = yONeu; 
          wh = wh/5;
          e = e/5;//epsilon
          zoomFaktor =zoomFaktor*5;
          println("Zoomfaktor: "+zoomFaktor);
          starteThreads(xU, yU, maxiterations, massFuerUnendlich, wh, nummerThread, x0, y0, Julia,e,DEM);  
          redraw();
        }else if (keyPressed == false){
          if(!Julia){//Wenn Julia-Menge gezeichnet kann kein c-Wert entnommen werden
            Julia = true;
            e= e/5;
            x0 = map(mouseX,0,width,(float)xU,(float)xO);
            y0 = map(mouseY,height,0,(float)yU,(float)yO);
            C = new Complex(x0,y0);//c-Wert speichern
            xU = -1.8; 
            yU = -1.8; 
            xO = 1.8;
            yO = 1.8;
            zoomFaktor=1;
            wh = xO-xU;
            println("Neuer Wert für die Konstante c:  x0= "+x0+"; y0 ="+ y0 +";");
            starteThreads(xU, yU, maxiterations, massFuerUnendlich, wh, nummerThread,x0,y0,Julia,e,DEM);
            redraw();
          }
        }
     }
   if (mouseButton == RIGHT){   
     if (keyPressed == true && keyCode == SHIFT){//Orbit von Beginn an einzeichnen
          orbitZeichnen = true;
          farbig = true;//bei jedem Klick neue Farbe
          orbitZeichnenAb = 1;
          anzahlOrbitPunkte = 800;
          punktGroesse =2;
          orbitZeichnen = true;
          float xH = map(mouseX,0,width,(float)xU,(float)xO); 
          float yH = map(mouseY,0,height, (float)yO,(float)yU);
          z0 = new Complex(xH,yH);
          println("Orbit Punkte zeichnen von Beginn");
          redraw();
         
     }else if (keyPressed == false && Julia){ //Orbit ab Element 500 einzeichnen
          orbitZeichnen = true;
          orbitZeichnenAb = 500;
          anzahlOrbitPunkte = 2000;
          punktGroesse =4;   
          farbig = false;
          orbitZeichnen = true;
          float xH = map(mouseX,0,width,(float)xU,(float)xO); 
          float yH = map(mouseY,0,height, (float)yO,(float)yU);
          z0 = new Complex(xH,yH);
          println("Orbit Punkte zeichnen ab n = 500");
          redraw();
     }
 }  
}
/////////////////////////////////////////////////////////////////
void keyPressed() {
  //skiziert die Mandelbrotmenge
  if (key == 'm'){
     FPzeichnen = false;
     cWerteEintragen= false;
     nummerThread =0;
     background(0);
     Julia = false;
     println("Mandelbrot");
     threads = new  ArrayList<Threads>(); 
     starteThreads(xU, yU, maxiterations, massFuerUnendlich, wh, nummerThread, x0, y0, Julia,e,DEM);
  }
  if (key == 'c'){
      println("Spezielle c-Werte eintragen");
      gelbC = true;//gelben C-Werte zeichnen
      cWerteEintragen=true;
      redraw();
  }
  
  if (key == 'p'){
      println("Spezielle c-Werte eintragen (gelb)");
      rotC = true;//roten C-Werte zeichnen (indiff FP)
      punktGroesse = 4;
      cWerteEintragen=true;
      redraw();
  }   
  
  if (key == 'd'){
      DEM = !DEM;
      if(DEM) println("Distance-Estimation-Methode verwenden.");
       else println("Fluchtgeschwindigkeit verwenden.");
      nummerThread =0;
      background(0);
      threads = new  ArrayList<Threads>(); 
      starteThreads(xU, yU, maxiterations, massFuerUnendlich, wh, nummerThread,x0,y0, Julia,e,DEM);
      redraw();
  }   
  
  if (key == '+'){//Iterationsgrenze erhöhen
     nummerThread =0;
     background(0);
     maxiterations *= 1.2; println("Iterationsgrenze: "+maxiterations);
     threads = new  ArrayList<Threads>(); 
     starteThreads(xU, yU, maxiterations, massFuerUnendlich, wh, nummerThread,x0,y0, Julia,e,DEM);
  }
  if (key == '-') {//Iterationsgrenze veringern
      nummerThread =0;
      background(0);
      maxiterations /= 1.2;println("Iterationsgrenze: "+maxiterations);
      threads = new  ArrayList<Threads>(); 
      starteThreads(xU, yU, maxiterations, massFuerUnendlich, wh, nummerThread,x0,y0, Julia,e,DEM);  
  }
  if (key == 'f'){//Fixpunkte einzeichnen
     FPzeichnen=true;
     redraw();
  }
  
  if (key == 'z'){//zoomen in der Mitte
     double xUNeu, xONeu, yUNeu, yONeu;//Temp. Speicher
     nummerThread =0;
     background(0);
     xUNeu = xU+0.25*(xO-xU);yUNeu = yU+0.25*(yO-yU);
     xONeu = xO-0.25*(xO-xU);yONeu = yO-0.25*(yO-yU);
     xU = xUNeu;xO = xONeu; 
     yU =yUNeu; yO = yONeu; 
     wh=wh/2;
     zoomFaktor =zoomFaktor*2;
     println("Zoomfaktor: "+zoomFaktor);
     threads = new  ArrayList<Threads>(); 
     starteThreads(xU, yU, maxiterations, massFuerUnendlich, wh, nummerThread,x0,y0, Julia,e,DEM);
  }
  if (key == 'l'){//Bild nach links verschieben
     nummerThread =0;
     background(0);
     xO = xO + wh/10;
     xU = xU + wh/10;
     println("Verschiebung nach Links");
     threads = new  ArrayList<Threads>(); 
     starteThreads(xU, yU, maxiterations, massFuerUnendlich, wh, nummerThread,x0,y0, Julia,e,DEM);
  }
  if (key == 'r'){//Bild nach rechts verschieben
     nummerThread =0;
     background(0);
     xO = xO - wh/10;
     xU = xU - wh/10;
     println("Verschiebung nach Rechts");
     threads = new  ArrayList<Threads>(); 
     starteThreads(xU, yU, maxiterations, massFuerUnendlich, wh, nummerThread,x0,y0, Julia,e,DEM);
  }
   if (key == 'u'){//Bild nach unten verschieben
     nummerThread =0;
     background(0);
     yO = yO + wh/10;
     yU = yU + wh/10;
     println("Verschiebung nach unten");
     threads = new  ArrayList<Threads>(); 
     starteThreads(xU, yU, maxiterations, massFuerUnendlich, wh, nummerThread,x0,y0, Julia,e,DEM);
  }
  if (key == 'o'){//bild nach oben verschieben
     nummerThread =0;
     background(0);
     yO = yO - wh/10;
     yU = yU - wh/10;
     println("Verschiebung nach oben");
     threads = new  ArrayList<Threads>(); 
     starteThreads(xU, yU, maxiterations, massFuerUnendlich, wh, nummerThread,x0,y0, Julia,e,DEM);
  }
  if (key == 's') save("julia.png");
  redraw();
}
/////////////////////////////////////////////////////////////////
